﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;
using System.Threading;
using System.Runtime.InteropServices;
using LibUsbDotNet;
using LibUsbDotNet.Info;
using LibUsbDotNet.Main;
using System.Collections.ObjectModel;

namespace USBTEST_Visuall_CS
{

    public partial class Form1 : Form
    {
        public static UsbDevice MyUsbDevice;
        public static UsbDeviceFinder MyUsbFinder = new UsbDeviceFinder(0x16C0, 0x05DC);

       
        
        public static byte[] bytes = new byte[1024];
        public static IntPtr buffer = Marshal.AllocHGlobal(bytes.Length);
        public static int lengthTransferred, actualLength;


        public const byte CMD_LED_OFF = 0;
        public const byte CMD_LED_ON = 1;
        public const byte CMD_DATA_OUT = 2;
        public const byte CMD_DATA_WRITE = 3;
        public const byte CMD_DATA_IN = 4;

        // From UsbSetupPacket RequestType docs (or libusb headers or USB spec)
        public const byte USB_DEVICE_TO_HOST = 128;
        public const byte USB_HOST_TO_DEVICE = 0;
        public const byte USB_TYPE_VENDOR = 64;
        public const byte USB_RECIP_DEVICE = 0;

        public Form1()
        {
            InitializeComponent();

        }

        private void Form_Aktive(object sender, EventArgs e)
        {

            ErrorCode ec = ErrorCode.None;
            

           
            // http://stackoverflow.com/questions/537573/how-to-get-intptr-from-byte-in-c-sharp
           
          

            try
            {
                // Find and open the usb device.
                MyUsbDevice = UsbDevice.OpenUsbDevice(MyUsbFinder);

                // If the device is open and ready
                if (MyUsbDevice == null) throw new Exception("VUSB Device Not Found.");
                
                

                // If this is a "whole" usb device (libusb-win32, linux libusb-1.0)
                // it exposes an IUsbDevice interface. If not (WinUSB) the 
                // 'wholeUsbDevice' variable will be null indicating this is 
                // an interface of a device; it does not require or support 
                // configuration and interface selection.
                IUsbDevice wholeUsbDevice = MyUsbDevice as IUsbDevice;
                if (!ReferenceEquals(wholeUsbDevice, null))
                {
                    // This is a "whole" USB device. Before it can be used, 
                    // the desired configuration and interface must be selected.
                   // Console.WriteLine("Whole USB device...");
                    textBox5.Text = "Whole USB device...";

                    // Select config #1
                    wholeUsbDevice.SetConfiguration(1);

                    // Claim interface #0.
                    wholeUsbDevice.ClaimInterface(0);

                }
            }
            catch (Exception ex)
            {
                
                //Console.WriteLine((ec != ErrorCode.None ? ec + ":" : String.Empty) + ex.Message)
                textBox4.Text = ex.Message;
                
              
            }
            finally
            {
                if (MyUsbDevice != null)
                {
                    if (MyUsbDevice.IsOpen)
                    {
                        // If this is a "whole" usb device (libusb-win32, linux libusb-1.0)
                        // it exposes an IUsbDevice interface. If not (WinUSB) the 
                        // 'wholeUsbDevice' variable will be null indicating this is 
                        // an interface of a device; it does not require or support 
                        // configuration and interface selection.
                        IUsbDevice wholeUsbDevice = MyUsbDevice as IUsbDevice;
                        if (!ReferenceEquals(wholeUsbDevice, null))
                        {
                            // Release interface #0.
                            wholeUsbDevice.ReleaseInterface(0);
                        }
                    }
                }
            }


        }

        private void button1_Click(object sender, EventArgs e)
        {
            // LED ON
            UsbSetupPacket LED_ON = new UsbSetupPacket(USB_DEVICE_TO_HOST + USB_TYPE_VENDOR + USB_RECIP_DEVICE,
                CMD_LED_ON, 0, 0, 1024);

            //Console.WriteLine("LED ON...");
            MyUsbDevice.ControlTransfer(ref LED_ON, buffer, bytes.Length, out lengthTransferred);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            UsbSetupPacket LED_OFF = new UsbSetupPacket(USB_DEVICE_TO_HOST + USB_TYPE_VENDOR + USB_RECIP_DEVICE,
               CMD_LED_OFF, 0, 0, 1024);

            MyUsbDevice.ControlTransfer(ref LED_OFF, buffer, bytes.Length, out lengthTransferred);
            Console.WriteLine("...LED OFF");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string str = Convert.ToString(textBox1.Text);
            UsbSetupPacket DATA_IN = new UsbSetupPacket(USB_HOST_TO_DEVICE + USB_TYPE_VENDOR + USB_RECIP_DEVICE,
     CMD_DATA_IN, 0, 0, 1024);
            
            byte[] utf8 = System.Text.Encoding.UTF8.GetBytes(str);

            Buffer.BlockCopy(utf8, 0, bytes, 0, utf8.Length); // copy utf-8 encoded string to bytes
            bytes[utf8.Length] = 0; // NULL terminate to maintain compatibility with C client        
            Marshal.Copy(bytes, 0, buffer, utf8.Length + 1); // copy null-terminated string to IntPtr

            MyUsbDevice.ControlTransfer(ref DATA_IN, buffer, utf8.Length + 1, out lengthTransferred);

            Console.WriteLine("Wrote " + lengthTransferred + " bytes (" + utf8.Length +
                " chars and NULL) with DATA IN: " + str);
            
                
                 
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            // DATA OUT
            UsbSetupPacket DATA_OUT = new UsbSetupPacket(USB_DEVICE_TO_HOST + USB_TYPE_VENDOR + USB_RECIP_DEVICE,
                 CMD_DATA_OUT, 0, 0, 1024);

            MyUsbDevice.ControlTransfer(ref DATA_OUT, buffer, bytes.Length, out lengthTransferred);
            Marshal.Copy(buffer, bytes, 0, lengthTransferred); // copy transferred bytes from IntPtr to bytes
            // Find the terminating NULL and thus actual length
            for (actualLength = 0; actualLength < lengthTransferred && bytes[actualLength] != 0; actualLength++)
            {
                 
            }

/*            Console.WriteLine("Got " + lengthTransferred +
            " bytes (" + actualLength +
               " chars and NULL) with DATA OUT: " 
            + System.Text.Encoding.UTF8.GetString(bytes, 0, actualLength));
 */
            
            textBox3.Text = Convert.ToString(lengthTransferred);
            textBox2.Text = System.Text.Encoding.UTF8.GetString(bytes, 0, actualLength);
            

           
        }

        

        private void button4_Click(object sender, EventArgs e)
        {
            // DATA OUT
            UsbSetupPacket DATA_OUT = new UsbSetupPacket(USB_DEVICE_TO_HOST + USB_TYPE_VENDOR + USB_RECIP_DEVICE,
                 CMD_DATA_OUT, 0, 0, 1024);

            MyUsbDevice.ControlTransfer(ref DATA_OUT, buffer, bytes.Length, out lengthTransferred);
            Marshal.Copy(buffer, bytes, 0, lengthTransferred); // copy transferred bytes from IntPtr to bytes
            // Find the terminating NULL and thus actual length
            for (actualLength = 0; actualLength < lengthTransferred && bytes[actualLength] != 0; actualLength++)
            {

            }

            Console.WriteLine("Got " + lengthTransferred +
            " bytes (" + actualLength +
               " chars and NULL) with DATA OUT: "
            + System.Text.Encoding.UTF8.GetString(bytes, 0, actualLength));

            textBox3.Text = Convert.ToString(lengthTransferred);
            textBox2.Text = System.Text.Encoding.UTF8.GetString(bytes, 0, actualLength);
           

        }

        private void _Close(object sender, FormClosedEventArgs e)
        {
            if (MyUsbDevice != null)  MyUsbDevice.Close();
            
            Marshal.FreeHGlobal(buffer);
        }
    }
}
